extends Node3D

@export var num_balls: int = 10
@export var force_strength: float = 10

# Called when the node enters the scene tree for the first time.
func _enter_tree():
	for i in range(num_balls):
		var x = randf_range(-10,10)
		var y = 2
		var z = randf_range(-10,10)
		
		var charge = randf_range(-1,1)
		#if charge > -0.8 and charge < 0:
		#	charge = -0.8
		#if charge < 0.8 and charge > 0:
		#	charge = 0.8
		
		var ball = preload("res://magnetic_ball.tscn").instantiate()
		
		ball.position = Vector3(x,y,z)
		ball.charge = charge
		
		self.add_child(ball)
		
		# add force field:
		var ffield = Node3D.new()
		ffield.set_script(MagneticForceField)
		ffield.charge = charge
		ffield.affected_objects_root = self
		ffield.force_strength = self.force_strength
		
		ball.add_child(ffield)

# Called every frame. 'delta' is the elapsed time since the previous frame.
func _process(delta):
	pass
