extends RigidBody3D

class_name ForceFieldAffected

var force_fields = []

@export var charge: float = -1.0
@export var charge_color_mesh: MeshInstance3D = null

@export var positive_charge_color: Color = Color.DARK_RED
@export var negative_charge_color: Color = Color.DARK_BLUE


# Called when the node enters the scene tree for the first time.
func _ready():
	var material = charge_color_mesh.get_active_material(0)
	charge_color_mesh.set_surface_override_material(0,material.duplicate())
	pass # Replace with function body.
	

# Called every frame. 'delta' is the elapsed time since the previous frame.
func _process(delta):
	
	var summed_force = Vector3.ZERO
	
	for field in force_fields:
		summed_force = summed_force + field.get_force(self)
	
	self.apply_central_force(summed_force)# + Vector3(0,-9.81,0))
	
	if charge_color_mesh != null:
		var material = charge_color_mesh.get_active_material(0)

		var color = negative_charge_color.lerp(positive_charge_color, 0.5 + 0.5 * charge)
		material.albedo_color = color
		

func add_force_field(force_field: ForceField):
	force_fields.append(force_field)
