extends Node2D

@export var mlp: MLP
@export var neuron_radius: float = 10.0
@export var space_between_layers: float = 100.0
@export var space_between_neurons: float = 50.0
@export var neuron_color = Color(1, 1, 1)  # white
@export var connection_color = Color(0, 0, 1)  # blue

func _draw():
	if mlp:
		var layer_position = Vector2(0, 0)
		for i in range(mlp.weights.size()):
			var neuron_position = Vector2(layer_position)
			for j in range(mlp.weights[i].size()):
				var neuron = mlp.weights[i][j]
				# draw neuron
				draw_circle(neuron_position, neuron_radius, neuron_color)
				# draw connections to the next layer
				if i < mlp.weights.size() - 1:
					var next_layer_position = Vector2(layer_position.x + space_between_layers, 0)
					for k in range(mlp.weights[i + 1].size()):
						var next_neuron_position = Vector2(next_layer_position)
						draw_line(neuron_position, next_neuron_position, connection_color)
						next_layer_position.y += space_between_neurons
				neuron_position.y += space_between_neurons
			layer_position.x += space_between_layers

func update_mlp(new_mlp: MLP):
	mlp = new_mlp
